<!--
 * @Date: 2024-06-16 19:47:41
 * @LastEditors: Sneed
 * @LastEditTime: 2024-06-23 21:32:29
 * @FilePath: /belleson-frontend/Users/mache/Documents/demo/cps-web/src/views/console/basic-data/tpm-data.vue
-->
<template>
    <el-main style="height: 100%;">
        <el-card shadow="never" style="height: 100%;">
            <el-tabs v-model="activeName" type="card" class="custom-tabs" @tab-click="handleClick">
                <el-tab-pane label="保养项" name="1">
                    <el-container>
                        <el-header>
                            <Header key="1" ref="header1" :config="config1" v-model="params" :rules="rules1"
                                @search="search1" @submit="submit1" :formData="form1" :selection="selection1"
                                exportUrlTpl="/api/smis/maintain-item/export/template"
                                exportUrl="/api/smis/maintain-item/export"
                                uploadUrl="/api/smis/maintain-item/import-maintain-item" @del="del1" />
                        </el-header>
                        <el-main>
                            <TpmData1 key="1" ref="tpmData1" :apiObj="apiObj1" :params="params" :cols="cols1"
                                @selection-change="handleSelectionChange1" @del="del1" @edit="edit1" />
                        </el-main>
                    </el-container>
                </el-tab-pane>
                <el-tab-pane label="点检项目" name="2">
                    <tpmComp1></tpmComp1>
                </el-tab-pane>
                <el-tab-pane label="故障类型" name="3">
                    <el-container>
                        <el-header>
                            <Header key="2" ref="header2" :config="config2" v-model="params" :rules="rules2"
                                @search="search2" @submit="submit2" :formData="form2" :selection="selection2"
                                exportUrlTpl="/api/smis/malfunction/export-template"
                                exportUrl="/api/smis/malfunction/export-malfunctionType"
                                uploadUrl="/api/smis/malfunction/import-malfunctionType" @del="del2" />
                        </el-header>
                        <el-main>
                            <TpmData1 key="2" ref="tpmData2" :apiObj="apiObj2" :params="params" :cols="cols2"
                                @selection-change="handleSelectionChange2" @del="del2" @edit="edit2" />
                        </el-main>
                    </el-container>
                </el-tab-pane>
                <el-tab-pane label="机器类型" name="4">
                    <tpmComp2 />
                </el-tab-pane>
            </el-tabs>
        </el-card>
    </el-main>

</template>

<script>
import Header from './tpm-data-header.vue'
import TpmData1 from './tpm-data1.vue'
import tpmComp1 from './tpmComp1.vue'
import tpmComp2 from './tpmComp2.vue'
export default {
    components: {
        Header,
        TpmData1,
        tpmComp1,
        tpmComp2
    },
    data() {
        return {
            activeName: '1',
            params: {
                keyWord: '',
                status: 1
            },
            rules1: {
                code: [
                    { required: true, message: '请输入' },
                ],
                name: [
                    { required: true, message: '请输入' },
                ]
            },
            config1: {
                labelWidth: 120,
                formItems: [
                    {
                        component: 'input',
                        label: '保养项编号',
                        name: 'code',
                        options: {
                            placeholder: '',
                            maxlength: 100,
                        }
                    },
                    {
                        component: 'input',
                        label: '保养项名称',
                        name: 'name',
                        options: {
                            multiple: false,
                            data: []
                        },
                        disabled: false
                    },
                    {
                        component: 'input',
                        label: '保养要求',
                        name: 'requirement',
                        type: 'textarea',
                        options: {
                            multiple: false,
                            data: []
                        },
                        disabled: false
                    },
                    {
                        component: 'input',
                        label: '备注',
                        name: 'remark',
                        type: 'textarea',
                        options: {
                            multiple: false,
                            data: []
                        },
                        disabled: false
                    },
                    {
                        component: 'select',
                        label: '状态',
                        name: 'status',
                        options: {
                            multiple: false,
                            items: [
                                {
                                    value: 1,
                                    label: '启用'
                                },
                                {
                                    value: 0,
                                    label: '停用'
                                },
                            ]
                        },
                        disabled: false
                    }
                ]
            },
            cols1: [
                {
                    prop: 'code',
                    label: '保养项编号'
                },
                {
                    prop: 'name',
                    label: '保养项名称'
                },
                {
                    prop: 'requirement',
                    label: '保养要求'
                },
                {
                    prop: 'remark',
                    label: '备注'
                },
                {
                    prop: 'statusName',
                    label: '状态'
                },
            ],
            apiObj1: {
                get: async (data) => {
                    let params = {
                        ...data,
                        ...this.params
                    }
                    return await this.$HTTP.get(`/api/smis/maintain-item/page`, {}, { params }).then(res => {
                        res.data.records = res?.data?.records.map(v => {
                            return {
                                ...v,
                                statusName: v.status ? '启用' : '禁用'
                            }
                        })
                        return res
                    })
                }
            },
            form1: {
                status: 1,
            },
            apiObj2: {
                get: async (data) => {
                    let params = {
                        ...data,
                        ...this.params,
                        malfunctionTypeCodeOrName: this.params.keyWord
                    }
                    return await this.$HTTP.get(`/api/smis/malfunction/page`, {}, { params }).then(res => {
                        res.data.records = res?.data?.records.map(v => {
                            return {
                                ...v,
                                statusName: v.status ? '启用' : '禁用'
                            }
                        })
                        return res
                    })
                }
            },
            selection1: [],
            rules2: {
                code: [
                    { required: true, message: '请输入' },
                ],
                name: [
                    { required: true, message: '请输入' },
                ]
            },
            config2: {
                labelWidth: 120,
                formItems: [
                    {
                        component: 'input',
                        label: '故障类型编号',
                        name: 'code',
                        options: {
                            placeholder: '',
                            maxlength: 100,
                        }
                    },
                    {
                        component: 'input',
                        label: '故障类型名称',
                        name: 'name',
                        options: {
                            multiple: false,
                            data: []
                        },
                        disabled: false
                    },
                    {
                        component: 'input',
                        label: '备注',
                        name: 'remark',
                        type: 'textarea',
                        options: {
                            multiple: false,
                            data: []
                        },
                        disabled: false
                    },
                    {
                        component: 'select',
                        label: '状态',
                        name: 'status',
                        options: {
                            multiple: false,
                            items: [
                                {
                                    value: 1,
                                    label: '启用'
                                },
                                {
                                    value: 0,
                                    label: '停用'
                                },
                            ]
                        },
                        disabled: false
                    }
                ]
            },
            cols2: [
                {
                    prop: 'code',
                    label: '故障类型编号'
                },
                {
                    prop: 'name',
                    label: '故障类型名称'
                },
                {
                    prop: 'remark',
                    label: '备注'
                },
                {
                    prop: 'statusName',
                    label: '状态'
                },
            ],
            form2: {
                status: 1,
            },
            selection2: []
        }
    },
    methods: {
        search1() {
            this.$refs?.tpmData1.query(this.params)
        },
        handleSelectionChange1(selection) {
            this.selection1 = selection
        },
        submit1(val) {
            console.log(val)
            if (!val.id) {
                this.$HTTP.post(`/api/smis/maintain-item/create-maintain-item`, val).then(res => {
                    if (res.success) {
                        this.search1()
                    } else {
                        this.$message.error(res.msg)
                    }
                })
            } else {
                this.$HTTP.post(`/api/smis/maintain-item/edit-maintain-item`, val).then(res => {
                    if (res.success) {
                        this.search1()
                    } else {
                        this.$message.error(res.msg)
                    }
                })
            }
        },
        del1(selection, type) {
            this.$HTTP.post(`/api/smis/maintain-item/delete-maintain-item`, {}, {
                params: {
                    ids: selection.map(v => v.id).toString(),
                    type
                }
            }).then(res => {
                if (res.success) {
                    this.search1()
                } else {
                    this.$message.error(res.msg)
                }
            })
        },
        edit1(row) {
            this.config1.formItems[0].disabled = true
            this.config1.formItems[1].disabled = true
            // this.form1 = { ...row }
            this.$refs?.header1.edit(row)
        },
        edit2(row) {
            this.config2.formItems[0].disabled = true
            this.config2.formItems[1].disabled = true
            this.form2 = { ...row }
            this.$refs?.header2.edit(row)
        },
        search2() {
            this.$refs?.tpmData2.query(this.params)
        },
        handleSelectionChange2(selection) {
            this.selection1 = selection
        },
        submit2(val) {
            console.log(val)
            // if (!val.id) {
            this.$HTTP.post(`/api/smis/malfunction/save`, val).then(res => {
                if (res.success) {
                    this.search2()
                } else {
                    this.$message.error(res.msg)
                }
            })
            // }
            // else {
            //     this.$HTTP.post(`/api/smis/malfunction/save`, val).then(res => {
            //         if (res.success) {
            //             this.search2()
            //         } else {
            //             this.$message.error(res.msg)
            //         }
            //     })
            // }
        },
        del2(selection, type) {
            this.$HTTP.delete(`/api/smis/malfunction/delete`, {}, {
                params: {
                    malfunctionTypeIds: selection.map(v => v.id).toString(),
                    type
                }
            }).then(res => {
                if (res.success) {
                    this.search2()
                } else {
                    this.$message.error(res.msg)
                }
            })
        }
    },
}
</script>

<style lang="scss">
.custom-tabs {
    height: 100%;
}

.custom-tabs .el-tabs__content {
    height: calc(100% - 40px);
}

.custom-tabs .el-tab-pane {
    height: 100%;
}
</style>